
 -- Bindings for folks to set in the Blizzard Keybindings Menu --
BINDING_HEADER_SEMIBARS = "Semi Extra Bars";

_G["BINDING_NAME_CLICK Semi_EB_Bar3Button1:LeftButton"] = "Extra Bar 3 Button 1";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button2:LeftButton"] = "Extra Bar 3 Button 2";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button3:LeftButton"] = "Extra Bar 3 Button 3";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button4:LeftButton"] = "Extra Bar 3 Button 4";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button5:LeftButton"] = "Extra Bar 3 Button 5";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button6:LeftButton"] = "Extra Bar 3 Button 6";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button7:LeftButton"] = "Extra Bar 3 Button 7";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button8:LeftButton"] = "Extra Bar 3 Button 8";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button9:LeftButton"] = "Extra Bar 3 Button 9";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button10:LeftButton"] = "Extra Bar 3 Button 10";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button11:LeftButton"] = "Extra Bar 3 Button 11";
_G["BINDING_NAME_CLICK Semi_EB_Bar3Button12:LeftButton"] = "Extra Bar 3 Button 12";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button1:LeftButton"] = "Extra Bar 4 Button 1";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button2:LeftButton"] = "Extra Bar 4 Button 2";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button3:LeftButton"] = "Extra Bar 4 Button 3";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button4:LeftButton"] = "Extra Bar 4 Button 4";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button5:LeftButton"] = "Extra Bar 4 Button 5";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button6:LeftButton"] = "Extra Bar 4 Button 6";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button7:LeftButton"] = "Extra Bar 4 Button 7";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button8:LeftButton"] = "Extra Bar 4 Button 8";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button9:LeftButton"] = "Extra Bar 4 Button 9";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button10:LeftButton"] = "Extra Bar 4 Button 10";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button11:LeftButton"] = "Extra Bar 4 Button 11";
_G["BINDING_NAME_CLICK Semi_EB_Bar4Button12:LeftButton"] = "Extra Bar 4 Button 12";

-- On_Load --

function Semi_Extra_Bars_OnLoad(self)
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_LOGIN");
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("UNIT_ENTERING_VEHICLE");
	self:RegisterEvent("UNIT_ENTERED_VEHICLE");
	self:RegisterEvent("UNIT_EXITING_VEHICLE");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
end

function Semi_OrientOptions_OnLoad(self)
		--Setting Inital Text for Orient Menu
	--Semi_OrientOptionsTitle:SetText(Semi_Orient_String_Title);
	_G[self:GetName().."Title"]:SetText(Semi_Orient_String_Title);
	_G[self:GetName().."Info"]:SetText(Semi_Orient_String_Info);
	_G[self:GetName().."Info2"]:SetText(Semi_Orient_String_Info2);
	panel = Semi_OrientOptions;
	panel.name = "Flyout Buttons Info";
	panel.parent = "Semi";
	self:SetBackdrop(BACKDROP_SEMI_16);
	BackdropTemplateMixin.OnBackdropLoaded(self);
	self:SetBackdropColor(0,0,0,1);
	InterfaceOptions_AddCategory(panel);
end

--On_Event--

function Semi_Extra_Bars_OnEvent(self, event, ...)
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 = ...;
	if IsAddOnLoaded("Semi_Extra_Bars") then
		if event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_LOGIN" or (event=="ADDON_LOADED" and arg1=="Semi_Extra_Bars") then
			if UnitClass("Player") == "Druid" then
				for i=1,12 do
					_G["Semi_EB_Bar4Button"..i]:SetAttribute("action", i + 84)
				end
			else
				for i=1,12 do
					_G["Semi_EB_Bar4Button"..i]:SetAttribute("action", i + 108)
				end
			end
			for j=1, 2 do --Horiz Bar 3 and 4 use blizzard frame - but do not want the grey button background
				for i=1, 12 do
					_G["Semi_EB_Bar"..j.."Button"..i.."FloatingBG"]:SetAlpha(0);
					_G["Semi_EB_Vert_Bar"..j.."Button"..i.."FloatingBG"]:SetAlpha(0);
				end
				
			end
			
			Semi_Bar_StateDriver("Semi_EB_Bar1", SF_EB_1_State, Semi_EB_Vehicle);
			Semi_Bar_StateDriver("Semi_EB_Bar2", SF_EB_2_State, Semi_EB_Vehicle);
			Semi_Bar_StateDriver("Semi_EB_Bar3", SF_EB_3_State, Semi_EB_Vehicle);
			Semi_Bar_StateDriver("Semi_EB_Bar4", SF_EB_4_State, Semi_EB_Vehicle);
			Semi_Bar_StateDriver("Semi_EB_Vert_Bar1", SF_EB_Vert_1_State, Semi_EB_Vehicle);
			Semi_Bar_StateDriver("Semi_EB_Vert_Bar2", SF_EB_Vert_2_State, Semi_EB_Vehicle);

			Semi_GridChoice();
			--set the flyout orientation for each bar to default or user specified direction
			Semi_EB_Set_Direction("Semi_EB_Bar1Button", Semi_EB_H_1_Orien_Text);
			UIDropDownMenu_SetText(SemiExtraBars_Bar1_DropDownMenu, Semi_EB_H_1_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Bar2Button", Semi_EB_H_2_Orien_Text);
			UIDropDownMenu_SetText(SemiExtraBars_Bar2_DropDownMenu, Semi_EB_H_2_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Bar3Button", Semi_EB_H_3_Orien_Text);
			UIDropDownMenu_SetText(SemiExtraBars_Bar3_DropDownMenu, Semi_EB_H_3_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Bar4Button", Semi_EB_H_4_Orien_Text);
			UIDropDownMenu_SetText(SemiExtraBars_Bar4_DropDownMenu, Semi_EB_H_4_Orien_Text);
			
			Semi_EB_Set_Direction("Semi_EB_Vert_Bar1Button", Semi_EB_V_1_Orien_Text);
			UIDropDownMenu_SetText(SemiExtraBars_V_Bar1_DropDownMenu, Semi_EB_V_1_Orien_Text);
			Semi_EB_Set_Direction("Semi_EB_Vert_Bar2Button", Semi_EB_V_2_Orien_Text);
			UIDropDownMenu_SetText(SemiExtraBars_V_Bar2_DropDownMenu, Semi_EB_V_2_Orien_Text);
		end
	end	
end

function Semi_LinkDrag(bar, relativeTo, point, relativePoint)
	if (not InCombatLockdown()) then
		bar:ClearAllPoints();
		bar:SetPoint(point, relativeTo, relativePoint);
		bar:Show();
		bar:EnableMouse(true);
	end
end

function Semi_GridChoice()
	if (not InCombatLockdown()) then
		local barbutton = {
				"Semi_EB_Bar1Button",
				"Semi_EB_Bar2Button",
				"Semi_EB_Bar3Button",
				"Semi_EB_Bar4Button",
				"Semi_EB_Vert_Bar1Button",
				"Semi_EB_Vert_Bar2Button"
				};
		local showInt = 0;
		if (Semi_EB_Grid) then
			showInt = 1
		end
		for j= 1, 6 do
			for i=1, 12 do
				local gridbutton;
				gridbutton = getglobal(barbutton[j]..i);
				gridbutton:SetAttribute("showgrid", showInt);
				gridbutton:ShowGrid(ACTION_BUTTON_SHOW_GRID_REASON_CVAR);
			end				
		end
	end
end

function Semi_EB_Set_Direction(bar, direction)
	for i=1, 12 do
		gridbutton = _G[bar..i];
		gridbutton:SetAttribute("flyoutDirection", direction);
	end
end

function SetExtraBarScale(scale)
	Semi_EB_Bar1:SetScale(scale);
	Semi_EB_Bar1ActionBarDragButton:SetScale(scale);
	Semi_EB_Bar2:SetScale(scale);
	Semi_EB_Bar2ActionBarDragButton:SetScale(scale);
	Semi_EB_Bar3:SetScale(scale);
	Semi_EB_Bar3ActionBarDragButton:SetScale(scale);
	Semi_EB_Bar4:SetScale(scale);
	Semi_EB_Bar4ActionBarDragButton:SetScale(scale);
	Semi_EB_Vert_Bar1:SetScale(scale);
	Semi_EB_Vert_Bar1ActionBarDragButton:SetScale(scale);
	Semi_EB_Vert_Bar2:SetScale(scale);
	Semi_EB_Vert_Bar2ActionBarDragButton:SetScale(scale);
end

function Semi_EB_On_Change(self, arg1, arg2, checked)
	if arg2 == "Semi_EB_Bar1Button" then
		Semi_EB_H_1_Orien_Text = arg1;
		UIDropDownMenu_SetText(SemiExtraBars_Bar1_DropDownMenu, Semi_EB_H_1_Orien_Text);
	end
	if arg2 == "Semi_EB_Bar2Button" then
		Semi_EB_H_2_Orien_Text = arg1;
		UIDropDownMenu_SetText(SemiExtraBars_Bar2_DropDownMenu, Semi_EB_H_2_Orien_Text);
	end
	if arg2 == "Semi_EB_Bar3Button" then
		Semi_EB_H_3_Orien_Text = arg1;
		UIDropDownMenu_SetText(SemiExtraBars_Bar3_DropDownMenu, Semi_EB_H_3_Orien_Text);
	end
	if arg2 == "Semi_EB_Bar4Button" then
		Semi_EB_H_4_Orien_Text = arg1;
		UIDropDownMenu_SetText(SemiExtraBars_Bar4_DropDownMenu, Semi_EB_H_4_Orien_Text);
	end
	if arg2 == "Semi_EB_Vert_Bar1Button" then
		Semi_EB_V_1_Orien_Text = arg1;
		UIDropDownMenu_SetText(SemiExtraBars_V_Bar1_DropDownMenu, Semi_EB_V_1_Orien_Text);
	end
	if arg2 == "Semi_EB_Vert_Bar2Button" then
		Semi_EB_V_2_Orien_Text = arg1;
		UIDropDownMenu_SetText(SemiExtraBars_V_Bar2_DropDownMenu, Semi_EB_V_2_Orien_Text);
	end
	Semi_EB_Set_Direction(arg2, arg1);

end

function SemiExtraBars_Bar1_DropDownMenu_OnLoad()
local info = UIDropDownMenu_CreateInfo();
	--info.func = nil;

	info.isTitle = 1;
	info.text = "Horz 1";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	info.disabled = nil;
	info.isTitle = nil;
	info.notCheckable = nil;
	
	info.text = "Left";
	info.value = "LEFT";
	info.arg1 = "LEFT";
	info.arg2 = "Semi_EB_Bar1Button";
	if (info.value == Semi_EB_H_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Right";
	info.value = "RIGHT";
	info.arg1 = "RIGHT";
	info.arg2 = "Semi_EB_Bar1Button";
	if (info.value == Semi_EB_H_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Up";
	info.value = "UP";
	info.arg1 = "UP";
	info.arg2 = "Semi_EB_Bar1Button";
	if (info.value == Semi_EB_H_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Down";
	info.value = "DOWN";
	info.arg1 = "DOWN";
	info.arg2 = "Semi_EB_Bar1Button";
	if (info.value == Semi_EB_H_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
		
end
	
function SemiExtraBars_Bar1_DropDownMenuButton_OnClick(self)
	ToggleDropDownMenu(1, nil, SemiExtraBars_Bar1_DropDownMenu, "SemiExtraBars_Bar1_DropDownMenuButton", 0, 0);
end

function SemiExtraBars_Bar2_DropDownMenu_OnLoad()
local info = UIDropDownMenu_CreateInfo();
	--info.func = nil;
	
	info.isTitle = 1;
	info.text = "Horz 2";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	info.disabled = nil;
	info.isTitle = nil;
	info.notCheckable = nil;

	info.text = "Left";
	info.value = "LEFT";
	info.arg1 = "LEFT";
	info.arg2 = "Semi_EB_Bar2Button";
	if (info.value == Semi_EB_H_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Right";
	info.value = "RIGHT";
	info.arg1 = "RIGHT";
	info.arg2 = "Semi_EB_Bar2Button";
	if (info.value == Semi_EB_H_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Up";
	info.value = "UP";
	info.arg1 = "UP";
	info.arg2 = "Semi_EB_Bar2Button";
	if (info.value == Semi_EB_H_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Down";
	info.value = "DOWN";
	info.arg1 = "DOWN";
	info.arg2 = "Semi_EB_Bar2Button";
	if (info.value == Semi_EB_H_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
		
end
	
function SemiExtraBars_Bar2_DropDownMenuButton_OnClick(self)
	ToggleDropDownMenu(1, nil, SemiExtraBars_Bar2_DropDownMenu, "SemiExtraBars_Bar2_DropDownMenuButton", 0, 0);
end

function SemiExtraBars_Bar3_DropDownMenu_OnLoad()
local info = UIDropDownMenu_CreateInfo();
	--info.func = nil;
	
	info.isTitle = 1;
	info.text = "Horz 3";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	info.disabled = nil;
	info.isTitle = nil;
	info.notCheckable = nil;

	info.text = "Left";
	info.value = "LEFT";
	info.arg1 = "LEFT";
	info.arg2 = "Semi_EB_Bar3Button";
	if (info.value == Semi_EB_H_3_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Right";
	info.value = "RIGHT";
	info.arg1 = "RIGHT";
	info.arg2 = "Semi_EB_Bar3Button";
	if (info.value == Semi_EB_H_3_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Up";
	info.value = "UP";
	info.arg1 = "UP";
	info.arg2 = "Semi_EB_Bar3Button";
	if (info.value == Semi_EB_H_3_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Down";
	info.value = "DOWN";
	info.arg1 = "DOWN";
	info.arg2 = "Semi_EB_Bar3Button";
	if (info.value == Semi_EB_H_3_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
		
end
	
function SemiExtraBars_Bar3_DropDownMenuButton_OnClick(self)
	ToggleDropDownMenu(1, nil, SemiExtraBars_Bar3_DropDownMenu, "SemiExtraBars_Bar3_DropDownMenuButton", 0, 0);
end

function SemiExtraBars_Bar4_DropDownMenu_OnLoad()
local info = UIDropDownMenu_CreateInfo();
	--info.func = nil;
	
	info.isTitle = 1;
	info.text = "Horz 4";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	info.disabled = nil;
	info.isTitle = nil;
	info.notCheckable = nil;

	info.text = "Left";
	info.value = "LEFT";
	info.arg1 = "LEFT";
	info.arg2 = "Semi_EB_Bar4Button";
	if (info.value == Semi_EB_H_4_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Right";
	info.value = "RIGHT";
	info.arg1 = "RIGHT";
	info.arg2 = "Semi_EB_Bar4Button";
	if (info.value == Semi_EB_H_4_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Up";
	info.value = "UP";
	info.arg1 = "UP";
	info.arg2 = "Semi_EB_Bar4Button";
	if (info.value == Semi_EB_H_4_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Down";
	info.value = "DOWN";
	info.arg1 = "DOWN";
	info.arg2 = "Semi_EB_Bar4Button";
	if (info.value == Semi_EB_H_4_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
		
end
	
function SemiExtraBars_Bar4_DropDownMenuButton_OnClick(self)
	ToggleDropDownMenu(1, nil, SemiExtraBars_Bar4_DropDownMenu, "SemiExtraBars_Bar4_DropDownMenuButton", 0, 0);
end

function SemiExtraBars_V_Bar1_DropDownMenu_OnLoad()
local info = UIDropDownMenu_CreateInfo();
	--info.func = nil;
	
	info.isTitle = 1;
	info.text = "Vert 1";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	info.disabled = nil;
	info.isTitle = nil;
	info.notCheckable = nil;

	info.text = "Left";
	info.value = "LEFT";
	info.arg1 = "LEFT";
	info.arg2 = "Semi_EB_Vert_Bar1Button";
	if (info.value == Semi_EB_V_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Right";
	info.value = "RIGHT";
	info.arg1 = "RIGHT";
	info.arg2 = "Semi_EB_Vert_Bar1Button";
	if (info.value == Semi_EB_V_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Up";
	info.value = "UP";
	info.arg1 = "UP";
	info.arg2 = "Semi_EB_Vert_Bar1Button";
	if (info.value == Semi_EB_V_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Down";
	info.value = "DOWN";
	info.arg1 = "DOWN";
	info.arg2 = "Semi_EB_Vert_Bar1Button";
	if (info.value == Semi_EB_V_1_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
		
end
	
function SemiExtraBars_V_Bar1_DropDownMenuButton_OnClick(self)
	ToggleDropDownMenu(1, nil, SemiExtraBars_V_Bar1_DropDownMenu, "SemiExtraBars_V_Bar1_DropDownMenuButton", 0, 0);
end

function SemiExtraBars_V_Bar2_DropDownMenu_OnLoad()
local info = UIDropDownMenu_CreateInfo();
	--info.func = nil;
	
	info.isTitle = 1;
	info.text = "Vert 2";
	info.notCheckable = 1;
	UIDropDownMenu_AddButton(info);
	info.disabled = nil;
	info.isTitle = nil;
	info.notCheckable = nil;

	info.text = "Left";
	info.value = "LEFT";
	info.arg1 = "LEFT";
	info.arg2 = "Semi_EB_Vert_Bar2Button";
	if (info.value == Semi_EB_V_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Right";
	info.value = "RIGHT";
	info.arg1 = "RIGHT";
	info.arg2 = "Semi_EB_Vert_Bar2Button";
	if (info.value == Semi_EB_V_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Up";
	info.value = "UP";
	info.arg1 = "UP";
	info.arg2 = "Semi_EB_Vert_Bar2Button";
	if (info.value == Semi_EB_V_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
	
	info.text = "Down";
	info.value = "DOWN";
	info.arg1 = "DOWN";
	info.arg2 = "Semi_EB_Vert_Bar2Button";
	if (info.value == Semi_EB_V_2_Orien_Text) then
		info.checked = 1;
	else
		info.checked = nil;
	end
	info.func = Semi_EB_On_Change;
	UIDropDownMenu_AddButton(info);
		
end
	
function SemiExtraBars_V_Bar2_DropDownMenuButton_OnClick(self)
	ToggleDropDownMenu(1, nil, SemiExtraBars_V_Bar2_DropDownMenu, "SemiExtraBars_V_Bar2_DropDownMenuButton", 0, 0);
end